使用哈希集合来降低查找复杂度

来源:力扣(LeetCode)
给定字符串J 代表石头中宝石的类型,和字符串 S代表你拥有的石头。 S 中每个字符代表了一种你拥有的石头的类型,你想知道你拥有的石头中有多少是宝石。

J 中的字母不重复,J 和 S中的所有字符都是字母。字母区分大小写,因此"a"和"A"是不同类型的石头。

示例 1:
输入: J = “aA”, S = “aAAbbbb”
输出: 3

示例 2:
输入: J = “z”, S = “ZZ”
输出: 0
注意:

S 和 J 最多含有50个字母。
J 中的字符不重复。

使用Hash查找可以降低复杂度

class Solution {
    
    
    public int numJewelsInStones(String J, String S) {
    
    
        int jewelsCount = 0;
        Set<Character> jewelsSet = new HashSet<Character>();
        int jewelsLength = J.length(), stonesLength = S.length();
        for (int i = 0; i < jewelsLength; i++) {
    
    
            char jewel = J.charAt(i);
            jewelsSet.add(jewel);
        }
        for (int i = 0; i < stonesLength; i++) {
    
    
            char stone = S.charAt(i);
            if (jewelsSet.contains(stone)) {
    
    
                jewelsCount++;
            }
        }
        return jewelsCount;
    }
}

心得

此题目暴力的话可以采用双重for循环来解决,但是复杂度较高,而使用哈希集合的contains方法可以以O(1)复杂度的方式查找元素,降低复杂度。

猜你喜欢

转载自blog.csdn.net/qq_40258899/article/details/109097776